import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class Entrepreneur {

	private int id;
	private int idPersonne;
	private String entreprise;
	private Personne personne;
	
	private Connection con = null;
	private Statement stmt = null;

    public Entrepreneur (){
        // Chargement du pilote
        try {
              Class.forName("com.mysql.jdbc.Driver").newInstance();
        } catch (Exception e) {
              e.printStackTrace();
              System.exit(99);
        }

        // Connexion  la base de donnes MySQL "MTP-DB" avec le login "duvallet" 
        // et le mot de passe "duvallet"
        try {
            String DBurl = "jdbc:mysql://localhost:3306/MTP-DB";
            con = DriverManager.getConnection(DBurl,"duvallet","duvallet");
            stmt = con.createStatement();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public Entrepreneur (Personne personne, String entreprise){
    	this();
		this.personne=personne;
		this.entreprise = entreprise;
		idPersonne = personne.getId();
		id=insertEntrepreneur(entreprise, idPersonne);
	}
	
    public Entrepreneur (String nom, String prenom, int age, int numeroRue, String nomRue, 
                         String ville, String codePostal, String pays, String situation, String sexe, String entreprise){
    	this();
    	personne = new Personne (nom, prenom, age, numeroRue, nomRue, ville, codePostal, pays, situation, sexe);
		this.entreprise = entreprise;
		idPersonne = personne.getId();
		id=insertEntrepreneur(entreprise, idPersonne);
    }    
	
	public int insertEntrepreneur(String entreprise, int idPersonne) {
        ResultSet resultats = null;
        int idGenere = -1;
        try {
        	idGenere = stmt.executeUpdate("INSERT INTO Entrepreneur (idPersonne, Entreprise) " +
            		           "values ('"+idPersonne+"','"+entreprise+"')", Statement.RETURN_GENERATED_KEYS);
            resultats = stmt.getGeneratedKeys();
            if (resultats.next()) {
                idGenere = resultats.getInt(1);
            }
            resultats.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
		return idGenere;
	}

	public int getIdPersonne() {
		return idPersonne;
	}

	public void setIdPersonne(int idPersonne) {
		this.idPersonne = idPersonne;
	}

	public String getEntreprise() {
		return entreprise;
	}

	public void setEntreprise(String entreprise) {
		this.entreprise = entreprise;
	}

	public void afficheEntrepreneur (){
		personne.affichePersonne (idPersonne);
		System.out.print(entreprise);
		System.out.println();
	}
	
	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	public void setAge(int age){
		personne.affichePersonne(personne.getId());
		personne.setAge(age);
	}
	
	public void setNom(String nom){
		personne.setNom(nom);
	}
	
	public void setPrenom(String prenom){
		personne.setPrenom(prenom);
	}
	
	public static void main(String[] args) {
		Entrepreneur entrepreneur1 = new Entrepreneur ("Duvallet", "Claude", 36, 20, "rue des Fleurs", "Le Havre", "76610", "France", "Mari", "M", "Universit");
		Entrepreneur entrepreneur2 = new Entrepreneur ("Amanton", "Laurent", 40, 208, "rue des Lilas", "Le Havre", "76610", "France", "Mari", "M", "Universit");
		Entrepreneur entrepreneur3 = new Entrepreneur ("Sadeg", "Bruno", 56, 20, "rue des Orangers", "Paris", "76610", "France", "Divorc", "M", "Universit");
		System.out.println("=========Cration de trois entrepreneurs");
		entrepreneur1.afficheEntrepreneur();
		entrepreneur2.afficheEntrepreneur();
		entrepreneur3.afficheEntrepreneur();
		System.out.println("=========Modification d'un entrepreneur");
		entrepreneur1.setAge(40);
		entrepreneur1.afficheEntrepreneur();
		System.out.println("=========Ajout de trois ouvrages");
		Ouvrage ouvrage1 = new Ouvrage ("Pont",2004,2006,entrepreneur1);
		Ouvrage ouvrage2 = new Ouvrage ("Pont",2006,2008,entrepreneur1);
		Ouvrage ouvrage3 = new Ouvrage ("Pont",2007,2009,entrepreneur1);
	}

}
