import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


public class Ouvrage {
	private int id;
	private String type;
	private int debut;
	private int fin;
	private int idEntrepreneur;
	
    protected Connection con = null;
    protected Statement stmt = null;

    public Ouvrage (){
        // Chargement du pilote
        try {
              Class.forName("com.mysql.jdbc.Driver").newInstance();
        } catch (Exception e) {
              e.printStackTrace();
              System.exit(99);
        }

        // Connexion  la base de donnes MySQL "MTP-DB" avec le login "duvallet" 
        // et le mot de passe "duvallet"
        try {
            String DBurl = "jdbc:mysql://localhost:3306/MTP-DB";
            con = DriverManager.getConnection(DBurl,"duvallet","duvallet");
            stmt = con.createStatement();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    
	public Ouvrage (int id, String type, int debut, int fin, int idEntrepreneur){
		this();
		this.id = id;
		this.type = type;
		this.debut = debut;
		this.fin = fin;
		this.idEntrepreneur = idEntrepreneur;
	}

	public Ouvrage (String type, int debut, int fin, int idEntrepreneur){
		this();
		this.type = type;
		this.debut = debut;
		this.fin = fin;
		this.idEntrepreneur = idEntrepreneur;
		id = insertOuvrage (type, debut, fin, idEntrepreneur);
	}

	public int insertOuvrage (String type, int debut, int fin, int idEntrepreneur){
		int idGenere = -1;
		ResultSet resultats = null;
		try {
			String requete = "INSERT INTO Ouvrage (Type, Debut, Fin, idEntrepreneur) values ('"+type+"','"+debut+"','"+fin+"','"+idEntrepreneur+"')";
			idGenere = stmt.executeUpdate(requete, Statement.RETURN_GENERATED_KEYS);
			resultats = stmt.getGeneratedKeys();
			if (resultats.next()) {
				idGenere = resultats.getInt(1);
			}
			resultats.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return idGenere;
	}
	
	public Ouvrage (String type, int debut, int fin, Entrepreneur entrepreneur){
		this();
		this.type = type;
		this.debut = debut;
		this.fin = fin;
		this.idEntrepreneur = entrepreneur.getId();
		insertOuvrage(type, debut, fin, idEntrepreneur);
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public int getDebut() {
		return debut;
	}

	public void setDebut(int debut) {
		this.debut = debut;
	}

	public int getFin() {
		return fin;
	}

	public void setFin(int fin) {
		this.fin = fin;
	}

	public int getIdEntrepreneur() {
		return idEntrepreneur;
	}

	public void setIdEntrepreneur(int idEntrepreneur) {
		this.idEntrepreneur = idEntrepreneur;
	}	
}
