import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;


public class Personne {

	private int id;
	private String nom;
	private String prenom;
	private int age;
	private int numeroRue;
	private String nomRue;
	private String ville;
	private String codePostal;
	private String pays;
	private String situationMaritale;
	private String sexe;
	
	private Connection con = null;
	private Statement stmt = null;

    public Personne (){
        // Chargement du pilote
        try {
              Class.forName("com.mysql.jdbc.Driver").newInstance();
        } catch (Exception e) {
              e.printStackTrace();
              System.exit(99);
        }

        // Connexion  la base de donnes MySQL "MTP-DB" avec le login "duvallet" 
        // et le mot de passe "duvallet"
        try {
            String DBurl = "jdbc:mysql://localhost:3306/MTP-DB";
            con = DriverManager.getConnection(DBurl,"duvallet","duvallet");
            stmt = con.createStatement();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    
    public Personne (String nom, String prenom, int age, int numeroRue, String nomRue, 
            String ville, String codePostal, String pays, String situation, String sexe){
    	this ();
        id=insertPersonne(nom, prenom, age, numeroRue, 
		          nomRue, ville, codePostal, pays, situation, sexe);
        this.nom=nom;
        this.prenom=prenom;
        this.age=age;
        this.numeroRue=numeroRue;
        this.nomRue=nomRue;
        this.ville=ville;
        this.codePostal=codePostal;
        this.pays=pays;
        this.situationMaritale=situation;
        this.sexe=sexe;
    }    
	
    public Personne (Personne p){
    	this ();
    	id=p.getId();
    	nom=p.getNom();
    	prenom=p.getPrenom();
    	age=p.getAge();
    	numeroRue=p.getNumeroRue();
    	nomRue=p.getNomRue();
    	ville=p.getVille();
    	codePostal=p.getCodePostal();
    	pays=p.getPays();
    	situationMaritale=p.getSituationMaritale();
    	sexe=p.getSexe();
		updatePersonne();
    }    

    public void setPersonne (Personne p){
    	id=p.getId();
    	nom=p.getNom();
    	prenom=p.getPrenom();
    	age=p.getAge();
    	numeroRue=p.getNumeroRue();
    	nomRue=p.getNomRue();
    	ville=p.getVille();
    	codePostal=p.getCodePostal();
    	pays=p.getPays();
    	situationMaritale=p.getSituationMaritale();
    	sexe=p.getSexe();
		updatePersonne();
    }    
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
		updatePersonne();
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
		updatePersonne();
	}

	public String getPrenom() {
		return prenom;
	}

	public void setPrenom(String prenom) {
		this.prenom = prenom;
		updatePersonne();
	}

	public int getAge() {
		return age;
	}

	public void setAge(int age) {
		this.age = age;
		updatePersonne();
	}

	public int getNumeroRue() {
		return numeroRue;
	}

	public void setNumeroRue(int numeroRue) {
		this.numeroRue = numeroRue;
		updatePersonne();
	}

	public String getNomRue() {
		return nomRue;
	}

	public void setNomRue(String nomRue) {
		this.nomRue = nomRue;
		updatePersonne();
	}

	public String getVille() {
		return ville;
	}

	public void setVille(String ville) {
		this.ville = ville;
		updatePersonne();
	}

	public String getCodePostal() {
		return codePostal;
	}

	public void setCodePostal(String codePostal) {
		this.codePostal = codePostal;
		updatePersonne();
	}

	public String getPays() {
		return pays;
	}

	public void setPays(String pays) {
		this.pays = pays;
		updatePersonne();
	}

	public String getSituationMaritale() {
		return situationMaritale;
	}

	public void setSituationMaritale(String situationMaritale) {
		this.situationMaritale = situationMaritale;
		updatePersonne();
	}

	public String getSexe() {
		return sexe;
	}

	public void setSexe(String sexe) {
		this.sexe = sexe;
		updatePersonne();
	}

	private int insertPersonne (String nom, String prenom, int age, int numeroRue, String nomRue, 
			String ville, String codePostal, String pays, String situation, String sexe){
		ResultSet resultats = null;
		int idGenere = -1;
		try {
			idGenere = stmt.executeUpdate("INSERT INTO Personne (Nom, Prenom, Age, NumeroRue, NomRue, Ville, CodePostal, " +
					"Pays, SituationMaritale, Sexe) " +
					"values ('"+nom+"','"+prenom+"','"+age+"','"+numeroRue+"','"+nomRue+"','"+
					ville+"','"+codePostal+"','"+pays+"','"+situation+"','"+sexe+"')", Statement.RETURN_GENERATED_KEYS);
			resultats = stmt.getGeneratedKeys();
			if (resultats.next()) {
				idGenere = resultats.getInt(1);
			}
			resultats.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return idGenere;
	}

	private int updatePersonne (){
		String requete = "UPDATE Personne SET nom='"+nom+"', prenom='"+prenom+"', age='"+age+"', numeroRue='"+numeroRue+"',nomRue='"+nomRue+"',ville='"+
							ville+"',CodePostal='"+codePostal+"',Pays='"+pays+"',SituationMaritale='"+situationMaritale+"',Sexe='"+sexe+"'" +
							"WHERE id='"+id+"'";
		int idGenere = -1;
		try {
			idGenere = stmt.executeUpdate(requete);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return idGenere;
	}

	public void supprimePersonne (int id){
		try {
			stmt.executeUpdate("Delete From Personne Where id='"+id+"'");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void supprimePersonne (String nom, String prenom, int age){
		try {
			stmt.executeUpdate("Delete From Personne Where nom='"+nom+"' and prenom='"+prenom+"' and age='"+age+"'");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void affichePersonne (int id){
		ResultSet resultats = null;
		try {
			boolean encore = false;
			resultats = stmt.executeQuery("Select * From Personne Where id="+id);
			if (resultats != null) 
				encore = resultats.next();

			if (encore){
				System.out.print(resultats.getString(1)+" ");
				System.out.print(resultats.getString(2)+" ");
				System.out.print(resultats.getInt(3)+" ");
				System.out.print(resultats.getInt(4)+" ");
				System.out.print(resultats.getString(5)+" ");
				System.out.print(resultats.getString(6)+" ");
				System.out.print(resultats.getString(7)+" ");
				System.out.print(resultats.getString(8)+" ");
				System.out.print(resultats.getString(9)+" ");
				System.out.print(resultats.getString(10)+" ");
			}
			else
				System.out.println ("Il n'y a personne avec ce numero !");
			resultats.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
